//
//  CheckerboardPatternTestAppDelegate.m
//  CheckerboardPatternTest
//
//  Created by Andreas on 19.02.10.
//  Copyright 2010 Andreas Mayer. All rights reserved.
//

#import "CheckerboardPatternTestAppDelegate.h"
#import "NSColor_CheckerboardColor.h"


@interface CheckerboardPatternTestAppDelegate ()
- (void)updateGridColor;
@end


@implementation CheckerboardPatternTestAppDelegate

@synthesize window;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	color1 = [NSColor whiteColor];
	[colorWell1 setColor:color1];
	color2 = [NSColor grayColor];
	[colorWell2 setColor:color2];
	gridSize = 32;
	[self updateGridColor];
}

- (IBAction)changeColor1:(id)sender
{
	color1 = [sender color];
	[self updateGridColor];
}

- (IBAction)changeColor2:(id)sender
{
	color2 = [sender color];
	[self updateGridColor];
}

- (IBAction)changeGridSize:(id)sender
{
	gridSize = [sender intValue];
	[self updateGridColor];
}

- (void)updateGridColor
{
	gridColor = [NSColor checkerboardColorWithFirstColor:color1 secondColor:color2 squareWidth:gridSize];
	[mainView setColor:gridColor];
	[mainView setNeedsDisplay:YES];
}



@end
