//
//  AMColoredView.m
//  PrefsPane
//
//  Created by Andreas on Tue Mar 02 2004.
//  Copyright (c) 2004 Andreas Mayer. All rights reserved.
//

#import "AMColoredView.h"


@implementation AMColoredView

- (id)initWithFrame:(NSRect)frame andColor:(NSColor *)theColor
{
	self = [super initWithFrame:frame];
	if (self) {
		[self setColor:theColor];
	}
	return self;
}

- (id)initWithFrame:(NSRect)frame
{
	return [self initWithFrame:frame andColor:[NSColor clearColor]];
}

- (void)dealloc
{
	[color release];
	[super dealloc];
}


- (NSColor *)color
{
	return color;
}

- (void)setColor:(NSColor *)newColor
{
	if (newColor != color) {
		id old = color;
		color = [newColor copy];
		[old release];
		NSColor *rgbaColor = [color colorUsingColorSpaceName:NSDeviceRGBColorSpace];
		if (!rgbaColor) {
			isOpaque = NO;
			isClear = NO;
		} else {
			isOpaque = !([rgbaColor alphaComponent] < 1.0);
			isClear = ([color isEqualTo:[NSColor clearColor]] || ([[color colorUsingColorSpaceName:NSDeviceRGBColorSpace] alphaComponent] < 0.001));
		}
	}
}

- (void)drawRect:(NSRect)rect
{
	if (!isClear) {
		[color set];
		if (isOpaque) {
			NSRectFill(rect);
		} else {
			NSRectFillUsingOperation(rect, NSCompositeSourceOver);
		}
	}
}

- (BOOL)isOpaque
{
	return isOpaque;
}


@end
